#include <NMEAGPS.h>

#include <Wire.h>
#include <Arduino.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_LSM303_U.h>
using namespace NeoGPS;
String initiator;
String dataString;
char url[120];
String nothing;
long x = 12345678;
long zz;
long yy;
float bearing;
int zbearing;
long zdistance;

String latString;
String lonString;
String lat;
String lon;
String a;
long latitude;
long longitude;
char c;
long result;
int sendDataState = LOW; 
unsigned long millisCalc1; 
unsigned long previousMillis1;
int ledState;
float xxx;
float yyy;
float zzz;
float Pi = 3.14159;
double compass;
Adafruit_LSM303_Mag_Unified mag = Adafruit_LSM303_Mag_Unified(12345);
//NeoGPS::Location_t base( 532558000L, -43114000L ); // Llangefni
NeoGPS::Location_t base( 332558000L, -73114000L ); // Nowhere
//======================================================================
//  Program: NMEAaverage.ino
//
//  Description:  This program averages locations over time to compute
//                a higher-accuracy *static* location.  It also shows
//                how to use the distance functions in the Location class.
//
//  Prerequisites:
//     1) NMEA.ino works with your device (correct TX/RX pins and baud rate)
//     2) At least once sentence with a location field has been enabled
//
//  'Serial' is for debug output to the Serial Monitor window.
//
//======================================================================

#if defined( UBRR1H ) | defined( ID_USART0 )
  // Default is to use Serial1 when available.  You could also
  // use NeoHWSerial, especially if you want to handle GPS characters
  // in an Interrupt Service Routine.
  //#include <NeoHWSerial.h>
#else
  // Only one serial port is available, uncomment one of the following:
  //#include <NeoICSerial.h>
  //#include <AltSoftSerial.h>
  #include <NeoSWSerial.h>
  //#include <SoftwareSerial.h> /* NOT RECOMMENDED */
#endif

#include "GPSport.h"

#ifdef NeoHWSerial_h
  #define DEBUG_PORT NeoSerial
#else
  #define DEBUG_PORT Serial
#endif

//------------------------------------------------------------
// Check that the config files are set up properly

#if !defined( NMEAGPS_PARSE_GGA ) && \
    !defined( NMEAGPS_PARSE_GLL ) && \
    !defined( NMEAGPS_PARSE_RMC )
  #error You must uncomment at least one of NMEAGPS_PARSE_GGA, GGL or RMC in NMEAGPS_cfg.h!
#endif

#if !defined( GPS_FIX_LOCATION )
  #error You must uncomment GPS_FIX_LOCATION in GPSfix_cfg.h!
#endif

#if !defined( GPS_FIX_TIME )
  #error You must uncomment GPS_FIX_TIME in GPSfix_cfg.h!
#endif

#if !defined( GPS_FIX_DATE )
  #error You must uncomment GPS_FIX_DATE in GPSfix_cfg.h!
#endif

//------------------------------------------------------------

static NMEAGPS  gps;  // This parses the GPS characters
static gps_fix  fix;  // This holds the latest GPS fix

//------------------------------------------------------------

static gps_fix    first;            // good GPS data
static clock_t    firstSecs;        // cached dateTime in seconds since EPOCH
static Location_t avgLoc;           // gradually-calculated average location
static uint16_t   count;            // number of samples
static int32_t    sumDLat, sumDLon; // accumulated deltas
static bool       doneAccumulating; // accumulation completed

//------------------------------------------------------------

const char nCD  [] PROGMEM = "N";
const char nneCD[] PROGMEM = "NNE";
const char neCD [] PROGMEM = "NE";
const char eneCD[] PROGMEM = "ENE";
const char eCD  [] PROGMEM = "E";
const char eseCD[] PROGMEM = "ESE";
const char seCD [] PROGMEM = "SE";
const char sseCD[] PROGMEM = "SSE";
const char sCD  [] PROGMEM = "S";
const char sswCD[] PROGMEM = "SSW";
const char swCD [] PROGMEM = "SW";
const char wswCD[] PROGMEM = "WSW";
const char wCD  [] PROGMEM = "W";
const char wnwCD[] PROGMEM = "WNW";
const char nwCD [] PROGMEM = "NW";
const char nnwCD[] PROGMEM = "NNW";

const char * const dirStrings[] PROGMEM =
  { nCD, nneCD, neCD, eneCD, eCD, eseCD, seCD, sseCD, 
    sCD, sswCD, swCD, wswCD, wCD, wnwCD, nwCD, nnwCD };

const __FlashStringHelper *compassDir( uint16_t bearing ) // degrees CW from N
{
  const int16_t directions    = sizeof(dirStrings)/sizeof(dirStrings[0]);
  const int16_t degreesPerDir = 360 / directions;
        int8_t  dir           = (bearing + degreesPerDir/2) / degreesPerDir;

  while (dir < 0)
    dir += directions;
  while (dir >= directions)
    dir -= directions;

  return (const __FlashStringHelper *) pgm_read_ptr( &dirStrings[ dir ] );

} // compassDir

//------------------------------------------------------------

static void doSomeWork()
{
  static bool warned = false; // that we're waiting for a valid location
  if (fix.valid.location) {
      tone(4,2500,100);   // pin,pitch,duration
      delay(100);
      noTone(4);
  }
  if (fix.valid.location && fix.valid.date && fix.valid.time) {
      //tone(4,2500,100);   // pin,pitch,duration
      //delay(100);
      //noTone(4);

    if (count == 0) {
    
      // Just save the first good fix
      first = fix;
      firstSecs = (clock_t) first.dateTime;
      count = 1;

    } else {

      // After the first fix, accumulate locations until we have
      //   a good average.  Then display the offset from the average.

      if (warned) {
        // We were waiting for the fix to be re-acquired.
        warned = false;
        // DEBUG_PORT.println();
      }

      // DEBUG_PORT.print( count );

      if (!doneAccumulating) {

        // Enough time?
        if (((clock_t)fix.dateTime - firstSecs) > 1)
          doneAccumulating = true;
      }

      int32_t dLat, dLon;

      if (!doneAccumulating) {

        // Use deltas from the first location
        dLat = fix.location.lat() - first.location.lat();
        sumDLat += dLat;
        int32_t avgDLat = sumDLat / count;

        dLon = fix.location.lon() - first.location.lon();
        sumDLon += dLon;
        int32_t avgDLon = sumDLon / count;

        //  Then calculated the average location as the first location
        //     plus the averaged deltas.
        avgLoc.lat( first.location.lat() + avgDLat );
        avgLoc.lon( first.location.lon() + avgDLon );

        count++;
      }

      // DEBUG_PORT.print( ',' );
      // DEBUG_PORT.print( avgLoc.lat() );
      // DEBUG_PORT.print( ',' );
      // DEBUG_PORT.print( avgLoc.lon() );
      // DEBUG_PORT.print( ',' );
      dLat = avgLoc.lat() - fix.location.lat();
      // DEBUG_PORT.print( dLat );
      // DEBUG_PORT.print( ',' );
      dLon = avgLoc.lon() - fix.location.lon();
      // DEBUG_PORT.print( dLon );

      // Calculate the distance from the current fix to the average location
      float avgDistError = avgLoc.DistanceKm( fix.location );
      // DEBUG_PORT.print( ',' );
      // DEBUG_PORT.print( avgDistError * 100000.0 ); // cm

      // Calculate the bearing from the current fix to the average location.
      //   NOTE: other libraries will have trouble with this calculation,
      //   because these coordinates are *VERY* close together.  Naive
      //   floating-point calculations will not have enough significant
      //   digits.
      float avgBearingErr = fix.location.BearingTo( base );
      float bearing       = avgBearingErr * Location_t::DEG_PER_RAD;
      // DEBUG_PORT.print( ',' );
      // DEBUG_PORT.print( bearing, 6 );
      // DEBUG_PORT.print( ',' );
      // DEBUG_PORT.print( compassDir( bearing ) );


      // Calculate a point that is 10km away from the average location,
      //   at the error bearing
      Location_t tenKmAway( avgLoc );
      tenKmAway.OffsetBy( 10.0 / Location_t::EARTH_RADIUS_KM, avgBearingErr );
      // DEBUG_PORT.print( ',' );
      // DEBUG_PORT.print( tenKmAway.lat() );
      // DEBUG_PORT.print( ',' );
      // DEBUG_PORT.print( tenKmAway.lon() );

      // Calculate the bearing from the average location to that point.
      //    This should be very close to the avgBearingErr, and will
      //    reflect the calculation error.  This is because the
      //    current fix is *VERY* close to the average location.
      float tb = avgLoc.BearingToDegrees( tenKmAway );
      // DEBUG_PORT.print( ',' );
      // DEBUG_PORT.print( tb, 6 );
      // DEBUG_PORT.println();      
      // DEBUG_PORT.print("Bearing:           ");// DEBUG_PORT.println( bearing, 6 );
      // DEBUG_PORT.print("Compass direction: ");// DEBUG_PORT.println( compassDir( bearing ) );
      // DEBUG_PORT.println();
    }

  } else {
    if (!warned) {
      warned = true;
      // DEBUG_PORT.print( F("Waiting for fix...") );
    } else {
      // DEBUG_PORT.print( '.' );
    }
  }

} // doSomeWork

//------------------------------------------------------------

static void GPSloop()
{
  while (gps.available( gps_port )) 
  {
    fix = gps.read();
    doSomeWork();
  }

} // GPSloop

//------------------------------------------------------------


void setup()
{  
  tone(4,2500,1000);   // pin,pitch,duration
  delay(1000);
  noTone(4);
  Wire.begin(26);                // join i2c bus with address #25
  Wire.onReceive(receiveEvent); // register event
  Wire.onRequest(requestEvent); // register event
  // Start the normal trace output
   DEBUG_PORT.begin(9600);      // Remove this line for running on Mega with USB cable disconnected.

  // DEBUG_PORT.print( F("NMEAaverage.INO: started\n") );
  // DEBUG_PORT.print( F("  fix object size = ") );
  // DEBUG_PORT.println( sizeof(gps.fix()) );
  // DEBUG_PORT.print( F("  gps object size = ") );
  // DEBUG_PORT.println( sizeof(gps) );
  // DEBUG_PORT.println( F("Looking for GPS device on " USING_GPS_PORT) );
  // DEBUG_PORT.println( F("Comparing current fix with averaged location.\n"
   //                     "count,avg lat,avg lon,dlat,dlon,distance(cm),"
   //                     "bearing deg,compass,lat/lon 10km away & recalc bearing") );
  // DEBUG_PORT.flush();

  // Start the UART for the GPS device
  gps_port.begin( 19200 );
  mag.enableAutoRange(true);
  /* Initialise the sensor */
  if(!mag.begin())
  {
    /* There was a problem detecting the LSM303 ... check your connections */
    DEBUG_PORT.println("Ooops, no LSM303 detected ... Check your wiring!");
    while(1);
  }
}

//------------------------------------------------------------

void loop()
{
  delay(100);
  sensors_event_t magEvent; 
  mag.getEvent(&magEvent);
  
// Observed readings:
int xMin =  -19;
int xMax =  22;
int yMin = -90;
int yMax = -49;
// Now normalise to min -50 and max 50:
  
  xxx = ((magEvent.magnetic.x - xMin)*100/(xMax-xMin))-50;
  yyy = ((magEvent.magnetic.y - yMin)*100/(yMax-yMin))-50;
  /* Display the results (magnetic vector values are in micro-Tesla (uT)) */
  Serial.print("X:  "); Serial.print(magEvent.magnetic.x); Serial.print("  ");
  Serial.print("Y:  "); Serial.print(magEvent.magnetic.y); Serial.print("  ");
  /* Display the normalised results*/
  Serial.print("Xn: "); Serial.print(xxx); Serial.print("  ");
  Serial.print("Yn: "); Serial.print(yyy); Serial.print("  ");
  //Serial.print("Z: "); Serial.print(zzz); Serial.print("  ");
  compass = (((atan2(yyy,xxx) * 180) / Pi));
  compass = compass + 180;
  Serial.print("Compass Heading: ");Serial.println(compass);
  
  unsigned long currentMillis = millis();
  millisCalc1 = currentMillis - previousMillis1;
  if (millisCalc1 >= 1000)                           // timer  .... 1,000
  {  
    if (ledState == LOW) 
    {
      ledState = HIGH;
    } 
    else 
    {
      ledState = LOW;
    }
    digitalWrite(8, ledState);
    previousMillis1 = currentMillis;
  }  
 // NeoGPS::Location_t base( 532558000L, -43114000L ); // Llangefni
 // NeoGPS::Location_t base( 332558000L, -73114000L ); 
  NeoGPS::Location_t base( latitude, longitude ); // Llangefni
  a="";
  lat="";
  lon="";
  latString="";
  lonString="";

    if (fix.valid.location) 
    {
      float range = fix.location.DistanceKm( base )*1000;
      // DEBUG_PORT.print("Range:             ");// DEBUG_PORT.println(range,3);  
      zdistance = range *1000;
    
      float avgBearingErr = fix.location.BearingTo( base );
      bearing       = avgBearingErr * Location_t::DEG_PER_RAD;
      // DEBUG_PORT.print("Bearing:           ");// DEBUG_PORT.println( bearing, 6 );
      // DEBUG_PORT.print("Compass direction: ");// DEBUG_PORT.println( compassDir( bearing ) );
      zbearing = bearing*100;                // Float to integer.
    }
  
  GPSloop();
  zz = (fix.location.lat()); // zz is a 'long integer'.
  yy = (fix.location.lon());
  //Serial.print("Current Ublox latitude: ");Serial.println(zz);
  //Serial.print("Current Ublox longitude: ");Serial.println(yy);

  if (sendDataState == LOW) // This switches data set that is transmitted to TC275 via I2C.
  {
    characterCompileA();
    sendDataState = HIGH;
  }
  else 
  {
    characterCompileB();
    sendDataState = LOW;
  }
// DEBUG_PORT.println(zz);
}                           // END OF MAIN LOOP
void requestEvent() 
{
  Wire.write(url);     // as expected by master
}
void receiveEvent(int howMany) // Recieves lat and long data from FONA via TC275 for calculating bearings and distances.
{
  //Serial.println("Here is data from TC275: "); 
  while (Wire.available())
  {
    char c = Wire.read(); // receive byte as a character
   // Serial.print(c); //Serial.print("Q");          // print the character
      if (isAlpha(c))         // analyse c for letters
      {
      //Serial.print("LETTER");
      a=a+c;                // string = string + character
      if (a=="LAT")
      {
       lon="";
       lat=a;
       //Serial.print(" Trigger word LAT detected!: ");//Serial.println(b);
       a="";
      } 
      if (a=="LONG")
      {
       lat="";
       lon=a;
       //Serial.print(" Trigger word LONG detected!: ");//Serial.println(d);
       a="";
      } 
    } 
      if (lat=="LAT")
      {
        if (isDigit(c))         // analyse c for numerical digit
        {
        latString=latString+c;                // string = string + character
        }
      }
      if (lon=="LONG")
      {
        if (isDigit(c))         // analyse c for numerical digit
        {
        lonString=lonString+c;                // string = string + character
        }
      }
  }    // While Loop
  result=(latString).toInt();
  latitude = result;
  result=(lonString).toInt();
  longitude = result *-1;
  //Serial.print("latString: ");Serial.println(latString);
  //Serial.print("lonString: ");Serial.println(lonString);
  //Serial.print("latitude integer from Fona: ");Serial.println(latitude);
  //Serial.print("longitude integer from Fona: ");Serial.println(longitude);
  //Serial.println();
  //NeoGPS::Location_t base( latitude, longitude); // Llangefni
}
void lookForLettersAndDigits()
{
  lookForLetters();
  lookForDigits(); 
  lookForLatitude();
  lookForLongitude();
}
void lookForLetters()
{
    if (isAlpha(c))         // analyse c for letters
    {
      //Serial.print("LETTER");
      a=a+c;                // string = string + character
      if (a=="LAT")
      {
       lon="";
       lat=a;
       //Serial.print("Trigger word LAT detected!: ");//Serial.println(b);
       a="";
      } 
      if (a=="LON")
      {
       lat="";
       lon=a;
       //Serial.print("Trigger word LON detected!: ");//Serial.println(d);
       a="";
      } 
    } 
}
void lookForDigits()
{
  if (lat=="LAT")
  {
    if (isDigit(c))         // analyse c for numerical digit
    {
      latString=latString+c;                // string = string + character
    }
  }
  if (lon=="LON")
  {
    if (isDigit(c))         // analyse c for numerical digit
    {
      lonString=lonString+c;                // string = string + character
    }
  }
}
void lookForLatitude()
{
  if (lat=="LAT")
  {
      result=(latString).toInt();
      latitude = result;
      //Serial.println("");
      //Serial.print("Latitude: ");Serial.println(latitude);
  }
}
void lookForLongitude()
{
  if (lon=="LON")
  {
      result=(lonString).toInt();
      longitude = result;
      //Serial.println("");
      //Serial.print("Longitude: ");Serial.println(longitude);
  }
}
void characterCompileA() // For sending Ublox bearing and distance data to TC275
{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This is where the data is compiled into a character ....
  dataString =  initiator  + "BEAR" + zbearing + "DIST" + zdistance + "COMP" + compass;  // Limited to 32 characters for some reason !!! ..... + ",LON" + yy .... Removed.
  int n = dataString.length();
  //Serial.print("Data string to send:     "); Serial.println(dataString);   
  //Serial.print("Size of string:  "); Serial.println(n);
  // Builds the url character:
      for (int aa=0;aa<=n;aa++)                                              
      {
          url[aa] = dataString[aa];
      }
  // DEBUG_PORT.print("Character data to send:  ");// DEBUG_PORT.println(url);
  // DEBUG_PORT.println("");
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
}
void characterCompileB() // For sending Ublox lat and long to TC275
{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This is where the data is compiled into a character ....
  dataString =  initiator  + "LOON" + yy + "LAAT" + zz;  // Limited to 32 characters for some reason !!! ..... + ",LON" + yy .... Removed.
  int n = dataString.length();
  // DEBUG_PORT.print("Data string to send:     ");// DEBUG_PORT.println(dataString);   
  // DEBUG_PORT.print("Size of string:  ");// DEBUG_PORT.println(n);
  // Builds the url character:
      for (int aa=0;aa<=n;aa++)                                              
      {
          url[aa] = dataString[aa];
      }
  // DEBUG_PORT.print("Character data to send:  ");// DEBUG_PORT.println(url);
  // DEBUG_PORT.println("");
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
}
